﻿Public Class ThermohygrologgerTrend

    Private Sub ThermohygrologgerTrend_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MaskedTextBox1.Text = 0
        ComboBox1.SelectedIndex = 1
        If Form1.logdat_num < Form1.logbufMAXKensuu Then
            TrackBar1.Maximum = Form1.logdat_num
            Label3.Text = Form1.logdat_num
        Else
            TrackBar1.Maximum = Form1.logbufMAXKensuu
            Label3.Text = Form1.logbufMAXKensuu
        End If
        Timer1.Enabled = True
    End Sub

    Private Sub TempHrScaleDisp()
        '温度,湿度スケール描画
        '
        Dim g1 As Graphics
        Dim i, j, k As Integer
        g1 = PictureBox1.CreateGraphics()
        g1.DrawLine(Pens.Black, New Point(40, 10), New Point(40, 490))
        j = 0
        k = 0
        For i = 0 To 12
            g1.DrawLine(Pens.Black, New Point(35, i * 40 + 10), New Point(45, i * 40 + 10))
            If (i = 0) Or (i = 2) Or (i = 4) Or (i = 6) Or (i = 8) Or (i = 10) Or (i = 12) Then
                g1.DrawString((50 - (j * 10) & "℃"), New Font("MS UI Gothic", 9), Brushes.Magenta, 0, i * 40 + 5)
                j = j + 1
            End If
            If (i = 1) Or (i = 2) Or (i = 3) Or (i = 4) Or (i = 5) Or (i = 6) Or (i = 7) Or (i = 8) Or (i = 9) Or (i = 10) Or (i = 11) Then
                g1.DrawString((100 - (k * 10) & "%"), New Font("MS UI Gothic", 9), Brushes.Blue, 50, i * 40 + 5)
                k = k + 1
            End If
        Next
        g1.Dispose()
    End Sub

    Private Sub TempHrDisp()
        'グラフ描画
        '1データの描画間隔:4,2,1ドット
        '横軸長さ:2304ドット=4ドット*(144*4)データ
        '横軸長さ:2304ドット=2ドット*(144*8)データ
        '横軸長さ:2304ドット=1ドット*(144*16)データ
        '
        Dim g2 As Graphics
        Dim i, j As Integer
        Dim year, month, day1, day2, hour1, hour2 As Integer
        Dim X1, X2, Y11, Y12, Y21, Y22 As Integer
        Dim disp_hour_pos As Boolean
        g2 = PictureBox2.CreateGraphics()
        g2.FillRectangle(Brushes.LightGray, 0, 0, 4000, 530)
        For i = 0 To 12
            g2.DrawLine(Pens.Black, New Point(0, i * 40 + 10), New Point(2304, i * 40 + 10))
        Next
        If (ComboBox1.SelectedIndex = 0) Then
            j = Integer.Parse(MaskedTextBox1.Text)
            For i = 0 To 576
                If (i + j + 1) < Form1.logbufMAXKensuu Then
                    year = Form1.year_dat(i + j + 1)
                    If year <> 0 Then
                        month = Form1.month_dat(i + j + 1)
                        hour1 = Form1.hour_dat(i + j)
                        hour2 = Form1.hour_dat(i + j + 1)
                        day1 = Form1.day_dat(i + j)
                        day2 = Form1.day_dat(i + j + 1)
                        X1 = i * 4
                        If ((i + j = 0)) Then
                            g2.DrawLine(Pens.Black, New Point(X1, 10), New Point(X1, 490))
                            g2.DrawString((year & "/" & month & "/" & day2), New Font("MS UI Gothic", 9), Brushes.Black, X1, 512)
                        End If
                        If (hour1 <> hour2) Then
                            If (day1 <> day2) Then
                                g2.DrawLine(Pens.Black, New Point(X1, 10), New Point(X1, 490))
                                g2.DrawString((year & "/" & month & "/" & day2), New Font("MS UI Gothic", 9), Brushes.Black, X1, 512)
                            Else
                                g2.DrawLine(Pens.Yellow, New Point(X1, 10), New Point(X1, 490))
                            End If
                            g2.DrawString((hour2), New Font("MS UI Gothic", 9), Brushes.Black, X1 - 4, 492)
                        End If
                    End If
                End If
            Next
            For i = 0 To 12
                g2.DrawLine(Pens.Black, New Point(0, i * 40 + 10), New Point(2304, i * 40 + 10))
            Next
            For i = 0 To 576
                If (i + j + 1) < Form1.logbufMAXKensuu Then
                    year = Form1.year_dat(i + j + 1)
                    If year <> 0 Then
                        X1 = i * 4
                        X2 = (i + 1) * 4
                        Y11 = 410 - Form1.temp_dat(i + j) * 8
                        Y21 = 450 - Form1.hr_dat(i + j) * 4
                        Y12 = 410 - Form1.temp_dat(i + j + 1) * 8
                        Y22 = 450 - Form1.hr_dat(i + j + 1) * 4
                        g2.DrawLine(Pens.Magenta, New Point(X1, Y11), New Point(X2, Y12))
                        g2.DrawLine(Pens.Blue, New Point(X1, Y21), New Point(X2, Y22))
                    End If
                End If
            Next
        End If
        '
        If (ComboBox1.SelectedIndex = 1) Then
            j = Integer.Parse(MaskedTextBox1.Text)
            For i = 0 To 1152
                If (i + j + 1) < Form1.logbufMAXKensuu Then
                    year = Form1.year_dat(i + j + 1)
                    If year <> 0 Then
                        month = Form1.month_dat(i + j + 1)
                        hour1 = Form1.hour_dat(i + j)
                        hour2 = Form1.hour_dat(i + j + 1)
                        day1 = Form1.day_dat(i + j)
                        day2 = Form1.day_dat(i + j + 1)
                        X1 = i * 2
                        If ((i + j = 0)) Then
                            g2.DrawLine(Pens.Black, New Point(X1, 10), New Point(X1, 490))
                            g2.DrawString((year & "/" & month & "/" & day2), New Font("MS UI Gothic", 9), Brushes.Black, X1, 512)
                        End If
                        If (hour1 <> hour2) Then
                            If (day1 <> day2) Then
                                g2.DrawLine(Pens.Black, New Point(X1, 10), New Point(X1, 490))
                                g2.DrawString((year & "/" & month & "/" & day2), New Font("MS UI Gothic", 9), Brushes.Black, X1, 512)
                            Else
                                g2.DrawLine(Pens.Yellow, New Point(X1, 10), New Point(X1, 490))
                            End If
                            g2.DrawString((hour2), New Font("MS UI Gothic", 7), Brushes.Black, X1 - 4, 492)
                        End If
                    End If
                End If
            Next
            For i = 0 To 12
                g2.DrawLine(Pens.Black, New Point(0, i * 40 + 10), New Point(2304, i * 40 + 10))
            Next
            For i = 0 To 1152
                If (i + j + 1) < Form1.logbufMAXKensuu Then
                    year = Form1.year_dat(i + j + 1)
                    If year <> 0 Then
                        X1 = i * 2
                        X2 = (i + 1) * 2
                        Y11 = 410 - Form1.temp_dat(i + j) * 8
                        Y21 = 450 - Form1.hr_dat(i + j) * 4
                        Y12 = 410 - Form1.temp_dat(i + j + 1) * 8
                        Y22 = 450 - Form1.hr_dat(i + j + 1) * 4
                        g2.DrawLine(Pens.Magenta, New Point(X1, Y11), New Point(X2, Y12))
                        g2.DrawLine(Pens.Blue, New Point(X1, Y21), New Point(X2, Y22))
                    End If
                End If
            Next
        End If
        '
        If (ComboBox1.SelectedIndex = 2) Then
            j = Integer.Parse(MaskedTextBox1.Text)
            For i = 0 To 2304
                If (i + j + 1) < Form1.logbufMAXKensuu Then
                    year = Form1.year_dat(i + j + 1)
                    If year <> 0 Then
                        month = Form1.month_dat(i + j + 1)
                        hour1 = Form1.hour_dat(i + j)
                        hour2 = Form1.hour_dat(i + j + 1)
                        day1 = Form1.day_dat(i + j)
                        day2 = Form1.day_dat(i + j + 1)
                        X1 = i * 1
                        If ((i + j = 0)) Then
                            disp_hour_pos = False
                            g2.DrawLine(Pens.Black, New Point(X1, 10), New Point(X1, 490))
                            g2.DrawString((year & "/" & month & "/" & day2), New Font("MS UI Gothic", 9), Brushes.Black, X1, 512)
                        End If
                        If (hour1 <> hour2) Then
                            If (day1 <> day2) Then
                                disp_hour_pos = False
                                g2.DrawLine(Pens.Black, New Point(X1, 10), New Point(X1, 490))
                                g2.DrawString((year & "/" & month & "/" & day2), New Font("MS UI Gothic", 9), Brushes.Black, X1, 512)
                            Else
                                g2.DrawLine(Pens.Yellow, New Point(X1, 10), New Point(X1, 490))
                            End If
                            If (disp_hour_pos) Then
                                disp_hour_pos = False
                                g2.DrawString((hour2), New Font("MS UI Gothic", 7), Brushes.Black, X1 - 4, 500)
                            Else
                                disp_hour_pos = True
                                g2.DrawString((hour2), New Font("MS UI Gothic", 7), Brushes.Black, X1 - 4, 492)
                            End If
                        End If
                    End If
                End If
            Next
            For i = 0 To 12
                g2.DrawLine(Pens.Black, New Point(0, i * 40 + 10), New Point(2304, i * 40 + 10))
            Next
            For i = 0 To 2304
                If (i + j + 1) < Form1.logbufMAXKensuu Then
                    year = Form1.year_dat(i + j + 1)
                    If year <> 0 Then
                        X1 = i * 1
                        X2 = (i + 1) * 1
                        Y11 = 410 - Form1.temp_dat(i + j) * 8
                        Y21 = 450 - Form1.hr_dat(i + j) * 4
                        Y12 = 410 - Form1.temp_dat(i + j + 1) * 8
                        Y22 = 450 - Form1.hr_dat(i + j + 1) * 4
                        g2.DrawLine(Pens.Magenta, New Point(X1, Y11), New Point(X2, Y12))
                        g2.DrawLine(Pens.Blue, New Point(X1, Y21), New Point(X2, Y22))
                    End If
                End If
            Next
        End If
        g2.Dispose()
    End Sub

    Private Sub PictureBox1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
        Timer1.Enabled = True
    End Sub

    Private Sub PictureBox2_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox2.Paint
        Timer2.Enabled = True
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        Timer2.Enabled = True
    End Sub

    Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.Scroll
        MaskedTextBox1.Text = TrackBar1.Value
    End Sub

    Private Sub MaskedTextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MaskedTextBox1.TextChanged
        Dim value_pos As Integer
        If Integer.TryParse(MaskedTextBox1.Text, value_pos) = True Then
            value_pos = Integer.Parse(MaskedTextBox1.Text)
        Else
            MaskedTextBox1.Text = 0
            value_pos = 0
        End If
        If value_pos > TrackBar1.Maximum Then
            TrackBar1.Value = TrackBar1.Maximum
            MaskedTextBox1.Text = TrackBar1.Maximum
        Else
            TrackBar1.Value = value_pos
        End If
        Timer2.Enabled = True
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Timer1.Enabled = False
        TempHrScaleDisp()
    End Sub

    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        Timer2.Enabled = False
        TempHrDisp()
    End Sub
End Class